// Set Goal Position
//  Move position to the full range
//  Since software serial is selected, dynamixel should be use at 57600bps or less.
//  1.select [SOFT]
//  2.compile & download

#include <dxlib.h>
#include <SoftwareSerial.h>

DXLIB dxif (true); // select software serial

int16_t maxpos, minpos;

void setup() {
  dxif.begin (57143);

  // Get max/min position limit
  dxif.ReadWordData (1, 8, (uint16_t *)&maxpos, NULL);
  dxif.ReadWordData (1, 6, (uint16_t *)&minpos, NULL);
}

void loop() {
  static int16_t gpos = 0, dir = 10;

  // Set goal position
  dxif.WriteWordData (1, 30, gpos, NULL);

  // Update target value
  gpos += dir;
  if (gpos >= maxpos) {
    gpos = maxpos;
    dir *= -1;
  } else if (gpos <= minpos) {
    gpos = minpos;
    dir *= -1;
  };

  delay (10);
}
